%undefine _missing_build_ids_terminate_build
%global _unpackaged_files_terminate_build 1
%global debug_package %{nil}

%if %{defined _project}
# define if building on openSUSE build service
%global build_on_obs       1
%global reconfigure_mode   0
%else
%define _project           local
%global build_on_obs       0
%global reconfigure_mode   0
%global _hardened_build    1
%endif
%global _prefix            /usr
%global sysconfdir         /etc/pistop
%global logdir             /var/log/svc

Name: pistop
Version: 1.0
Release: 1.1%{?dist}
Summary: Start/Stop services on file server startup/shutdown
%if %build_on_obs == 1
License: GPL-2.0
%else
License: GPLv2
%endif
URL: https://github.com/mbhangui/%{name}
Source0: http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.gz

%if %build_on_obs == 1
%if 0%{?suse_version}
BuildRequires: -post-build-checks
#!BuildIgnore: post-build-checks  
%endif
%endif
BuildRequires: libqmail-devel libqmail
Requires: user(qmaill)
Requires: group(nofiles)
Requires: daemontools ucspi-tcp coreutils util-linux rsync at

%description
pistop is a package that provides two services fclient and fserver.

fclient is a svscan service that monitors the uptime of a server running
fserver service on port 5555. shutdown is detected by a socket close

fserver is a svscan service that provides a socket on port 5555 and offers
rudimentary commands.

%prep
%autosetup

%build
%configure --prefix=%{_prefix} --sysconfdir=/etc/%{name} \
  --libexecdir=%{_prefix}/libexec/%{name}
%{__make} -s %{?_smp_mflags}
(
echo "---------------- INFORMATION ------------------------"
echo target         %_target
echo target_alias   %_target_alias
echo target_cpu     %_target_cpu
echo target_os      %_target_os
echo target_vendor  %_target_vendor
echo Project        %{_project}
echo Building %{name}-%{version}-%{release} Build %{_build} OS %{_os}
echo "------------------------------------------------------"
) > %{name}-rpm.info

%install
rm -rf $RPM_BUILD_ROOT
%{__make} -s DESTDIR=%{buildroot} install-strip
%{__mkdir_p} %{buildroot}%{sysconfdir}
install -m 0644 %{name}-rpm.info %{buildroot}%{sysconfdir}/%{name}-rpm.info

%files
%dir %attr(755,root,root)               %{_prefix}/libexec/%{name}
%ghost %dir %attr(0755,qmaill,nofiles)  %{logdir}
%ghost      %attr(-,qmaill,nofiles)     %{logdir}/*
%license COPYING
%attr(755,root,root)                    %{_prefix}/libexec/%{name}/client
%attr(755,root,root)                    %{_prefix}/libexec/%{name}/backup
%attr(755,root,root)                    %{_prefix}/libexec/%{name}/create_service
%attr(755,root,root)                    %{_prefix}/libexec/%{name}/server
%attr(644,root,root) %config(noreplace) %{sysconfdir}/%{name}-release
%attr(644,root,root) %config(noreplace) %{sysconfdir}/%{name}-rpm.info
%docdir %{_prefix}/share/doc/%{name}
%{_prefix}/share/doc/*

%pretrans
# stop fclient, fserver services before upgrade
if [ -d /run ] ; then
  rundir=/run/svscan
elif [ -d /var/run ] ; then
  rundir=/var/run/svscan
else
  rundir=/service
fi
for i in fclient fserver; do
  if [ ! -d /service/$i ] ; then
    continue
  fi
  %{_prefix}/bin/svstat /service/$i >/dev/null 2>&1
  if [ $? -eq 0 ] ; then
    %{__mkdir_p} ${rundir}/$i
    %{_prefix}/bin/svc -d /service/$i
    touch ${rundir}/$i/.down
  fi
done

%post
argv1=$1
if [ -z "$argv1" ] ; then
  argv1=0
fi
# we are doing upgrade
if [ $argv1 -eq 2 ] ; then # upgrade
  if [ -d /run ] ; then
    rundir=/run/svscan
  elif [ -d /var/run ] ; then
    rundir=/var/run/svscan
  else
    rundir=/service
  fi
  # refresh fclient, fserver services
  for i in fclient fserver update; do
    if [ ! -d /service/$i ] ; then
      continue
    fi
    # earlier installations did not have .options
    if [ ! -f /service/$i/variables/.options ] ; then
      %{__mkdir_p} /service/$i/variables
      options=`grep "^#" /service/$i/run | sed -n 2p | cut -c3-`
      if [ -n "$options" ] ; then
        echo $options > /service/$i/variables/.options
      fi
    fi
    %{_prefix}/sbin/minisvc --servicedir=/service --refreshsvc="/service/$i" --silent
    %{_prefix}/sbin/minisvc --servicedir=/service --service-name=$i \
      --export-variables=/service/$i/variables/.variables --force --silent
    %{_prefix}/bin/svok /service/$i >/dev/null 2>&1
    if [ $? -eq 0 -a -f ${rundir}/$i/.down ] ; then
      %{__rm} -f ${rundir}/$i/.down
      %{_prefix}/bin/svc -u /service/$i
    fi
  done
  exit 0
fi
for i in fclient fserver update; do
  if [ ! -d /service/$i ] ; then
    continue
  fi
  %{_prefix}/sbin/minisvc --servicedir=/service --service-name=$i \
    --export-variables=/service/$i/variables/.variables --force --silent
done

%preun
argv1=$1
if [ -z "$argv1" ] ; then
  argv1=0
fi
# we are doing upgrade
if [ $argv1 -eq 1 ] ; then
  exit 0
fi
if [ -d /service/fclient ] ; then
  service_name=fclient
elif [ -d /service/fserver ] ; then
  service_name=fserver
fi
echo "removing ${service_name} logs"
log_dir=%{logdir}/${service_name}
[ "$log_dir" != "/" ] && %{__rm} -fr $log_dir
echo "stopping and removing ${service_name} service"
/usr/libexec/pistop/create_service --servicedir=/service --service_name=${service_name} --del-service
/usr/libexec/pistop/create_service --servicedir=/service --service_name=update --del-service
/usr/libexec/pistop/create_service --servicedir=/service --service_name=rsync --del-service

%changelog
* Sat Apr 30 2022 05:43:45 +0000 Manvendra Bhangui <pistop@indimail.org> 1.0-1.1%{?dist}
Release 1.0 Start 28/08/2020
- Initial Release
- fixed syntax error in create_service
- terminate cat command on SIGTERM
- fixed shutdown script
- Added code to do backup in fserver
- redo logic to kill background jobs
- fixed path for pistop
- added backup script
- service run file - use relative path for variables to allow renaming of
  service directory
- obs integration
- backup - use absolute path in backup script
- use backup script in fclient service
- pistop.spec, debian/postinst: fixed typo causing postinst to hang
- update variables only if changed
- save variables using minisvc --export-variables
- package documentation
- added --silent parmeter to minisvc invocation
- added debian/source/format
- server.c: display pid when quitting
- create_service: added update service
- create_service: skip upgrade of pistop when clients are connected to
  fserver service
- create_service: create HOME variable for update service
- create_service: removed daemontools from auto-update
- create_service: use at command to run apt-get update
- server.c: removed unused variable pid
- create_service: do initial sleep of 5 minutes for network to be up
- create Maildir for mail delivery
- create_service: reworked update script
- fix QMAILQUEUE for root user
- create_service: reworked creation script for update service
- create_service: create QUEUE_BASE env variable
- create_service: create USER env variable
- create env variables for atd service for mail to work using qmail-direct
- create_service: fixed /lib/systemd/system/at.service.d/override.conf
- create_service: fixed update not getting skipped when no updates available
- create_service: added logging statements
- create_service: skip daemontools if clients are connected to fserver
  service
- create_service: skip updating UPGRADE, INTERVAL env variables
- create_service: added rsync service
- create_service: create shutdown script for fclient to unmount MDrive
- client.in: added command line option to umount MDrive
- backup.in: backup dir/files in its own directory
- backup.in: backup only when dest/backup exists
- reverted backup script to v1.4
- client.in: mount MDrive
- create_services.in: make fclient service silent
